#ifndef __AMS2DPOINTSET_HPP__
#define __AMS2DPOINTSET_HPP__

namespace ams
{

class tree2d; //class predeclaration


class pointset2d
{
public:
  amsarray<vect2> points;
  bool use_kdtree; //use a kdtree and all the fast point-set algorithms (K-nearest-neigbors, etc)
  ams::tree2d *kdtree; //must use a pointer when forward-referencings ... huh
  double epsilon;

  pointset2d();
  ~pointset2d();
  pointset2d& operator=(pointset2d &other);
  pointset2d(pointset2d& other);

  long add(vect2 pt);
  bool erase(vect2 pt);
  long has(vect2 pt);
  long nearest_neighbor(vect2 pt);
  void k_nearest_neighbor(vect2 pt, long K, ams::amsarray<vect2> *nearest);
  bool set_use_kdtree(bool value);



};



}


#endif
