#ifndef __AMS2DTREE_HPP__
#define __AMS2DTREE_HPP__

namespace ams
{

class tree2dnode
{
public:
  long parent;
  long childleft;
  long childright;

  pointset2d *parentset;
  long ind; //index of point in parentset
  box2d box;
  int axis;
  double epsilon;


  tree2dnode();
  ~tree2dnode();
  tree2dnode& operator=(tree2dnode& other);
  const tree2dnode& operator=(const tree2dnode& other);
  tree2dnode(tree2dnode& other);
  tree2dnode(const tree2dnode& other);



};

class tree2d
{
public:

  amsarray<tree2dnode> nodes;
  pointset2d *parentset;
  double epsilon;

  tree2d();
  ~tree2d();
  tree2d& operator=(tree2d& other);
  tree2d(tree2d &other);

  ams::vect2 getpt(long parentind);
  ams::vect2 getpt2(long treeind);
  void setparent(pointset2d* ptr);


  long haspoint(ams::vect2 pt);
  long addpoint(ams::vect2 pt);
  long add_node(ams::vect2 pt, long parent, long parentind);

  long deletepoint(ams::vect2 pt);
  long deletepoint(long ptsetind);

  void rebuild();

  //is pt2 within epsilon of pt1 along all axes?
  bool pt_equal(ams::vect2 pt1, ams::vect2 pt2);

};


};


#endif
