#ifndef __BOX_HPP__
#define __BOX_HPP__

namespace ams
{

class box
{
public:
  double *xmin;
  double *xmax;
  int ndims;

  box();
  ~box();
  box& operator=(const box& other);
  box(const box& other);

  void setdims(int _ndims);

  //is a point inside the box?
  bool iswithin(vect2 pt);
  bool iswithin(vect3 pt);
  bool iswithin(double x);
  bool iswithin(double x,double y);
  bool iswithin(double x, double y, double z);
  bool iswithin(std::vector<double> x);
  bool iswithin(std::vector<double> *x);

  //distance from a point to the box
  double distance(vect2 pt);
  double distance(vect3 pt);
  double distance(double x);
  double distance(double x,double y);
  double distance(double x, double y, double z);
  double distance(std::vector<double> x);
  double distance(std::vector<double> *x);


};


};
#endif //__BOX_HPP__
