#ifndef __COMPLEX_HPP__
#define __COMPLEX_HPP__

namespace ams
{
namespace cmp
{

class complex
{
public:
  double r,i;


  complex();
  ~complex();
  const complex& operator=(const complex& other);
  complex(const complex& other);

  complex(double _r, double _i);
  complex(double _r);
  const complex& operator=(const double& z);

  friend complex operator-(const complex& z); //negation sign

   complex operator+(const complex& z);
   complex operator-(const complex& z);
   complex operator*(const complex& z);
   complex operator/(const complex& z);

   complex operator+(const double & z);
   complex operator-(const double & z);
   complex operator*(const double & z);
   complex operator/(const double & z);

  bool isreal();
  bool isimag();
  bool iszero();
  double arg();
  double mag();
  const complex conj();

};

double arg(ams::cmp::complex z);

complex dtocomp(double _r, double _i);
double real(complex z);
double imag(complex z);
complex sin(complex z);
complex cos(complex z);
complex tan(complex z);
complex exp(complex z);
complex log(complex z);
double abs(complex z);
complex conj(complex z);

//need hyperbolic trig Functions
complex cosh(complex z);
complex sinh(complex z);
complex tanh(complex z);

//need inverse trig and inverse hyperbolic trig Functions

}; //end namespace cmp
}; //end namespace ams

#endif //__COMPLEX_HPP__
