#ifndef __VECT2_HPP__
#define __VECT2_HPP__

namespace ams
{

class vect2
{
public:

  double x,y;

  vect2();
  ~vect2();
  vect2& operator=(const vect2& other);
  vect2(const vect2& other);

  vect2 operator+(const vect2& rhs);
	vect2 operator-(const vect2& rhs);
	vect2 operator*(const double rhs);
	vect2 operator/(const double rhs);
	friend vect2 operator-(const vect2& rhs);

	double& operator[](int i);

};

class mat2
{
public:

  double a[2][2];

  mat2();
  ~mat2();
  mat2& operator=(const mat2& other);
  mat2(const mat2& other);

  mat2 operator+(const mat2& rhs);
	mat2 operator-(const mat2& rhs);
	mat2 operator*(const double& rhs);
	mat2 operator/(const double& rhs);
	mat2 operator*(const mat2& rhs);
	mat2 operator/(const mat2& rhs);
	friend mat2 operator-(const mat2& rhs);

  double& operator()(int I, int J);
  const double& operator()(int I, int J) const; //for const objects

};

vect2 dtov2(double x, double y);//
mat2 dtom2(double xx, double xy, double yx, double yy);//

mat2 mult(mat2 m1, double d);//
mat2 mult(double d, mat2 m1);//
mat2 mult(mat2 m1, mat2 m2);//
vect2 mult(mat2 m1, vect2 v1);//
vect2 mult(vect2 v1, mat2 m2);//
//mat2 madd(mat2 m1, mat2 m2);//
mat2 minverse(mat2 m1);//
double mdet(mat2 m1);//

//vect2 sub(vect2 v1, vect2 v2);//
//vect2 add(vect2 v1, vect2 v2);//
//vect2 mult(vect2 v1, double d); //

double vdot(vect2 v1, vect2 v2);//
vect2 normalize(vect2 v2);
double vnorm(vect2 v1);
double vcross(vect2 v1, vect2 v2);//
vect2 vproj(vect2 v1, vect2 v2);//
mat2 vtom2(vect2 v1, vect2 v2); //
mat2 transpose(mat2 m1);

//generates a random vector inside the unit circle
vect2 randvect2();
double arg(vect2);
double abs(vect2); //alias for norm



};
#endif //__VECT2_HPP__
