#ifndef __VECT4_HPP__
#define __VECT4_HPP__

namespace ams
{

class vect4
{
public:

  double a[4];

  vect4();
  ~vect4();
  vect4& operator=(const vect4& other);
  vect4(const vect4& other);

  vect4 operator+(const vect4& rhs);
  vect4 operator-(const vect4& rhs);
  vect4 operator*(const double& rhs);
  vect4 operator/(const double& rhs);
  friend vect4 operator-(const vect4& rhs);
  double& at(int I);

  double& operator[](int I);

};

class mat4
{
public:

  double a[16];
  double zero;
  mat4();
  ~mat4();
  mat4& operator=(const mat4& other);
  mat4(const mat4& other);

  mat4 operator+(const mat4& rhs);
  mat4 operator-(const mat4& rhs);
  mat4 operator*(const double& rhs);
  vect4 operator*(const vect4& rhs);
  mat4 operator/(const double& rhs);
  mat4 operator*(const mat4& rhs);
  friend mat4 operator-(const mat4& rhs);

  double& at(int I, int J);
  const double& at(int I, int J) const;
  double& operator()(int i, int j);
  const double& operator()(int i, int j) const;

};

  vect4 dtov4(double a0,double a1,double a2,double a3);
  vect4 v3tov4(vect3 v); //sets w to 1
  mat4 m3tom4(mat3 q);

  double mdet(mat4 b);
  mat4 minverse(mat4 b);

};
#endif //__VECT4_HPP__
