#ifndef __AMSARRAY_SORT_HEAD_HPP__
#define __AMSARRAY_SORT_HEAD_HPP__

namespace ams
{

  /////////////////////
  //class declaration//
  /////////////////////

  //a minimalist tree to perform sorting of an array
  class sorttree
  {
  public:
    long ind;
    sorttree* parent;
    sorttree* leftchild;
    sorttree* rightchild;

    sorttree();
    ~sorttree();
    sorttree& operator=(const sorttree& other);
    sorttree(const sorttree& other);


    sorttree* next(int enterfrom, int *count); //returns either the leftchild, rightchild, parent, or

  };

  /////////////////////////
  //function declarations//
  /////////////////////////
  template<typename T> void identity_permutation(ams::amsarray<T>& arr, ams::amsarray<long> *permutation);
  void identity_permutation(long N, ams::amsarray<long> *permutation);
  //bool isvalid_permutation(ams::amsarray<long> &permutation); //the only thing that comes to mind is O(N^2) - blech - skip for now
  //you can do it in O(N) with O(N) memory;
  void invert_permutation(ams::amsarray<long> *permutation);

  //reverses order of permutation
  void reverse_permutation(ams::amsarray<long> *permutation);


  //applies a permutation to an array
  template<typename T> void apply_permutation(ams::amsarray<long> &permutation, ams::amsarray<T> *arr);

  template<typename T> static void __intl_addtosorttree(ams::amsarray<T> *arrptr, ams::sorttree *rootnode, long ind);

  //iterates over the sorttree, starting from the root and proceeding until it returns NULL
  //enterfrom is updated each iteration
  sorttree* sorttree_next(sorttree *current, int *enterfrom);

  //generates a permutation list from a sort-tree
  void sorttree_collect(sorttree *rootnode, amsarray<long> *permutation);

  //generates a permutation list from a sort-tree
  //avoids dynamic allocation of permutation by supplying expected size N
  void sorttree_collect(sorttree *rootnode, amsarray<long> *permutation, long N);



  template<typename T> void sort_ascending_permutation(ams::amsarray<T> *arr, ams::amsarray<long> *permutation);
  template<typename T> void sort_ascending(ams::amsarray<T> *arr);
  template<typename T> void sort_descending(ams::amsarray<T> *arr);


};

#endif
