#ifndef __AMSARRAY_SORT_HPP__
#define __AMSARRAY_SORT_HPP__


namespace ams
{

  ///////////////////////////////////////////////////
  //Function Declarations in amsarray_sort.head.hpp//
  ///////////////////////////////////////////////////

  ////////////////////////
  //function definitions//
  ////////////////////////

  template<typename T> void identity_permutation(ams::amsarray<T>& arr, ams::amsarray<long> *permutation)
  {
    identity_permutation(arr->size(),permutation);
    return;
  }

  template<typename T> void apply_permutation(ams::amsarray<long> &permutation, ams::amsarray<T> *arr)
  {
    long I;
    ams::amsarray<T> arr2 = *arr;
    for(I=0;I<arr2.size();I++)
    {
      if(permutation[I]>=0&&permutation[I]<arr2.size())
      {
        arr->at(I) = arr2[permutation[I]];
      }
    }
    return;
  }


  template<typename T> static void __intl_addtosorttree(ams::amsarray<T> *arrptr, ams::sorttree *rootnode, long ind)
  {
    ams::sorttree *treeptr = rootnode;
    ams::sorttree *newnode = NULL;
    int b = 0;

    if(ind>=0&&ind<arrptr->size())
    {
      while(b==0)
      {

            if(arrptr->at(ind)<arrptr->at(treeptr->ind))
            {
              //array[ind] < array[treeptr.ind]
              if(treeptr->leftchild==NULL)
              {
                b = 1;
              }
              else
              {
                treeptr = treeptr->leftchild;
              }
            }
            else
            {
              //array[ind] >= array[treeptr.ind]
              if(treeptr->rightchild==NULL)
              {
                b = 2;
              }
              else
              {
                treeptr = treeptr->rightchild;
              }
            }
      }

      if(b==1)
      {
        newnode = new ams::sorttree();
        newnode->parent = treeptr;
        treeptr->leftchild = newnode;
        newnode->ind = ind;

      }
      else if(b==2)
      {
        newnode = new ams::sorttree();
        newnode->parent = treeptr;
        treeptr->rightchild = newnode;
        newnode->ind = ind;
      }
      else
      {
        printf("DEBUG: __intl_addtosorttree, b = %d: Shouldn't happen!\n",b);
      }

    }

    return;
  }

  template<typename T> void sort_ascending_permutation(ams::amsarray<T> *arr, ams::amsarray<long> *permutation)
  {
    sorttree root;
    long I;
    if(arr->size()>1)
    {
      root.ind = 0;
      for(I=1;I<arr->size();I++)
      {
        __intl_addtosorttree<T>(arr,&root,I);
      }
      sorttree_collect(&root,permutation,arr->size());
    }
    else if(arr->size()==1)
    {
      permutation->resize(1);
      permutation->at(0) = 0;
    }
    else
    {
      permutation->resize(0);
    }

    return;
  }

  template<typename T> void sort_ascending(ams::amsarray<T> *arr)
  {
    ams::amsarray<long> permutation;
    sort_ascending_permutation<T>(arr,&permutation);
    apply_permutation<T>(permutation, arr);
    return;
  }

  template<typename T> void sort_descending(ams::amsarray<T> *arr)
  {
    ams::amsarray<long> permutation;
    sort_ascending_permutation<T>(arr,&permutation);
    reverse_permutation(&permutation);
    apply_permutation<T>(permutation, arr);
    return;
  }




}



#endif
