import os,sys,subprocess,math;
from compilelib import *;
import shutil;
from distutils.dir_util import copy_tree as copy_tree; #this version does overwrites

libname = "amsmathutil2.mingw64"
targetname = "main_test.exe";

kwargs = dict();

include = "-I./include -I../../include_winx64";
kwargs['include'] = include;

kwargs['flags'] = "-fPIC";
kwargs['libdir'] = "-L./bin_winx64 -L../../lib_winx64";
kwargs['libflags'] = "";
#-fvisibility=hidden 
kwargs['linkerflags'] = "-static -static-libgcc -Wl,-rpath=."
kwargs['recurse'] = True;

#Set up the path
MinGWdir = "C:\\\\mingw64\\bin"; #The location of my mingw installation
pth = os.environ['PATH'];
os.environ['PATH'] = MinGWdir+';'+pth;

#1: Pull required binary dynamic libraries to the bin folder
#shutil.copy('../../lib_winx64/libamsimg.dll.a','./bin_winx64');
#shutil.copy('../../lib_winx64/libamsimg.dll','./bin_winx64');

#2: Pull updated versions of all include files to the include folder
#copy_tree('../../include_winx64/amsmath','./include/amsmath');

#find all source files except the main test file
files  = flist('./src',exts=['.c','.cpp'], recurse=True);
files = except_contains(files,['main_test.cpp']);
files2 = replaceexts(files,'.o');   #for each source file, find the corresponding object file
files3 = list_to_sss(files2);       #make a space-separated list to call the linker

#compile all source files in the list
gs_compile_list('x86_64-w64-mingw32-g++',files,**kwargs);
#archive all source files in a static library
ar_list(files2,'./bin_winx64/lib{}.a'.format(libname));

#X: Push any libraries to the common lib folder
shutil.copy('./bin_winx64/lib{}.a'.format(libname),'../../lib_winx64');
#shutil.copy('./bin_winx64/libamstxt.dll.a','../../lib_winx64');
#shutil.copy('./bin_winx64/libamstxt.dll','../../lib_winx64');

#Y: Push any changes to the include files to the common include folder
copy_tree('./include/','../../include_winx64/');
#shutil.copy('./include/amstxtlib.h','../../include_winx64');
