#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <amsutil/amsutil.hpp>
#include <amsmath/amsmath.hpp>
#include <amsgeom/amsgeom.hpp>


using namespace std;

namespace ams
{

pointset2d::pointset2d()
{
  points.resize(0);
  use_kdtree = 1;
  epsilon = 1.0E-9;
  kdtree = new ams::tree2d();
  kdtree->setparent(this);

  return;
}

pointset2d::~pointset2d()
{
  points.resize(0);
  use_kdtree = 0;
  epsilon = 0.0;
  delete kdtree;

  return;
}

pointset2d& pointset2d::operator=(pointset2d& other)
{
  if(this!=&other)
  {
    this->points = other.points;
    this->use_kdtree = other.use_kdtree;
    this->kdtree = other.kdtree;
  }
  return *this;
}

pointset2d::pointset2d(pointset2d& other)
{
  if(this!=&other)
  {
    *this = other;
  }
  return;
}




};
