#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <vector>
#include <string>

#include <amsmath/amsmath.hpp>

namespace ams
{

  bool isnan(double V)
  {
  	//needs to test whether x!=x - if true, is NaN. NaN isn't equal to itself.
  	bool ret = 0;
  	if(V!=V)
  	{
  		ret = 1;
  	}
  	return ret;
  }

  double arg(double x, double y)
  {
  	double ret = 0.0;
  	double z = sqrt(x*x+y*y);

  //take 3 - this is from my tested python library
   if(z>1.0E-10)
   {
  	 if(y<=x && y>=-x)
  	 {
  		 ret = asin(y/z);
  	 }
  	 else if(y>=x && y>=-x)
  	 {
  		 ret = acos(x/z);
  	 }
  	 else if(y>=x && y<=-x)
  	 {
  		 ret = pi-asin(y/z);
  	 }
  	 else
  	 {
  		 ret = 2.0*pi-acos(x/z);
  	 }

   }

   if(ret<0.0)
   {
  	 ret = 2.0*pi+ret;
   }

  	return ret;
  }

  //returns random double from 0 to 1
  double randd()
  {
  	return ((double) rand())/((double) RAND_MAX);
  }

  //returns random integer between LB and UB inclusive
  int randi(int LB, int UB)
  {
  	int ret = 0;
  	if(UB>LB)
  		ret = (int)(randd()*(double)(UB-LB+1)+(double)LB);
  	else
  		ret = LB;

  	return ret;
  }

  double dabs(double a)
  {
  	double ret;
  	if(a>=0) ret = a;
  	else ret = -a;
  	return ret;
  }

  //returns -1. 0, or 1
  double dsgn(double a)
  {
  	double ret = 0.0;
  	if(a>0.0)
  	{
  		ret = 1.0;
  	}
  	else if(a<0.0)
  	{
  		ret = -1.0;
  	}
  	else
  	{
  		ret = 0.0;
  	}
  	return ret;
  }

  //returns azimuth and elevation angles in radians in the standard coordinate system
  //for a given vector (x,y,z)
  int get_azel(double x, double y, double z, double *az, double *el)
  {
  	int ret = -2; //should never see this return
  	double n, rp;
  	n = ::sqrt(x*x+y*y+z*z);
  	if(n>0.0)
  	{
  		rp = ::sqrt(x*x+y*y);
  		if(rp>0.0)
  		{
  			ret = 1; //nonzero vector - should work
  			*az = arg(x,y);
  			*el = ::atan(z/rp);
  		}
  		else
  		{
  			ret = 0; //straight up or straight down
  			if(z>0.0)
  			{
  				*az = 0.0;
  				*el = pi/2.0;
  			}
  			else
  			{
  				*az = 0.0;
  				*el = -pi/2.0;
  			}
  		}
  	}
  	else
  	{
  		*az = 0.0;
  		*el = 0.0;
  		ret = -1; //zero vector - no real azimuth/elevation
  	}

  	return ret;
  }

  double min(double a, double b)
  {
    double ret;
    if(a<b)
    {
      ret = a;
    }
    else
    {
      ret = b;
    }
    return ret;
  }

  double max(double a, double b)
  {
    double ret;
    if(a>b)
    {
      ret = a;
    }
    else
    {
      ret = b;
    }
    return ret;
  }
  long min(long a, long b)
  {
    long ret;
    if(a<b)
    {
      ret = a;
    }
    else
    {
      ret = b;
    }
    return ret;
  }

  long max(long a, long b)
  {
    long ret;
    if(a>b)
    {
      ret = a;
    }
    else
    {
      ret = b;
    }
    return ret;
  }

} // namespace ams
