#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <vector>

#include <amsmath/amsmath.hpp>

#include <amsutil/amsutil.hpp>

using namespace std;
using namespace ams;

namespace ams
{

void test_amsarray2()
{
  long q1,q2,q3;
  amsarray<double> srtarray1;

  q1 = place_sorted<double>(&srtarray1,0.0);

  return;
}

void test_amsarray1()
{
  amsarray<double> Q;
  int I;

  Q.resize(10);
  //Q.setall(0); //there doesn't seem to be a safe default element for double

  printf_array(&Q,1);

  Q[0] = 1.0;
  Q[1] = 2;
  Q[3] = 3.5;
  Q[9] = 1.0;
  printf_array(&Q,1);
  Q.append(10);
  printf_array(&Q,1);
  Q.erase(1);
  printf_array(&Q,1);
  Q.reserve(10000000);
  for(I=0;I<10000000;I++)
  {
    Q.push_back(I);
    if(I%500000==0)
    {
      printf("I:%d  Q.length = %d, Q.reserved = %d\n",I,Q.length,Q.reserved);
    }
  }
  printf("I:%d  Q.length = %d, Q.reserved = %d\n",I,Q.length,Q.reserved);
  Q.resize(20);
  printf("I:%d  Q.length = %d, Q.reserved = %d\n",I,Q.length,Q.reserved);
  printf_array(&Q,1);

  for(I=0;I<10000000;I++)
  {
    Q.push_back(I);
    if(I%500000==0)
    {
      printf("I:%d  Q.length = %d, Q.reserved = %d\n",I,Q.length,Q.reserved);
    }
  }
  printf("I:%d  Q.length = %d, Q.reserved = %d\n",I,Q.length,Q.reserved);

  Q.resize(500);
  printf("I:%d  Q.length = %d, Q.reserved = %d\n",I,Q.length,Q.reserved);
  for(I=0;I<10;I++)
  {
    printf("Q.pop_front = %1.6g\n",Q.pop_front());
    printf("I:%d  Q.length = %d, Q.reserved = %d\n",I,Q.length,Q.reserved);
  }
  for(I=0;I<10;I++)
  {
    printf("Q.pop_back = %1.6g\n",Q.pop_back());
    printf("I:%d  Q.length = %d, Q.reserved = %d\n",I,Q.length,Q.reserved);
  }

  ams::amsarray<vect3> Z;
  Z.growfactor = 1.0;
  Z.autoshrink = 1;
  Z.resize(10);
  Z.erase(2,5);
  printf("Z.length = %d, Z.reserved=%d\n",Z.length,Z.reserved);


  return;
}

}
