#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include <vector>

#include <amsmath/amsmath.hpp>

#include <amsutil/amsutil.hpp>

using namespace std;
using namespace ams;

namespace ams
{

  void test_amsarraysort_3()
  {
    double d;
    long q1;
    amsarray<double> arr1;

    int I;
    for(I=0;I<10;I++)
    {
      d = randd();
      q1 = place_sorted<double>(&arr1,d);
      printf("place to insert %1.6g: %d\n",d,q1);
      insert_sorted(&arr1,d);
      printf_array(&arr1,1);
    }


    return;
  }

  void test_amsarraysort_2()
  {
    amsarray<double> arr1;
    long q1,q2;
    double d;

    //printf("%d\n",arr1.size());
    printf_array(&arr1,1);
    // arr1.prepend(1.0);
    // printf_array(&arr1,1);
    // arr1.prepend(2.0);
    // printf_array(&arr1,1);
    // arr1.prepend(3.0);
    // printf_array(&arr1,1);
    // arr1.prepend(4.0);
    // printf_array(&arr1,1);
    // arr1.prepend(5.0);
    // printf_array(&arr1,1);

    d = 0.0;
    q1 = place_sorted<double>(&arr1,d);
    printf("place to insert %1.6g: %d\n",d,q1);
    insert_sorted<double>(&arr1,d);

    printf_array(&arr1,1);
    d = 0.1;
    q1 = place_sorted<double>(&arr1,d);
    printf("place to insert %1.6g: %d\n",d,q1);
    insert_sorted<double>(&arr1,d);

    printf_array(&arr1,1);
    d = -1.2;
    q1 = place_sorted<double>(&arr1,d);
    printf("place to insert %1.6g: %d\n",d,q1);
    insert_sorted<double>(&arr1,d);

    printf_array(&arr1,1);
    d = 0.05;
    q1 = place_sorted<double>(&arr1,d);
    printf("place to insert %1.6g: %d\n",d,q1);
    insert_sorted<double>(&arr1,d);

    printf_array(&arr1,1);
    d = 0.0;
    q1 = place_sorted<double>(&arr1,d);
    printf("place to insert %1.6g: %d\n",d,q1);
    insert_sorted<double>(&arr1,d);

    printf_array(&arr1,1);
    d = 10.0;
    q1 = place_sorted<double>(&arr1,d);
    printf("place to insert %1.6g: %d\n",d,q1);
    insert_sorted<double>(&arr1,d);

    printf_array(&arr1,1);

    d = 10.0;
    q1 = find_sorted<double>(&arr1,d);
    printf("%1.6g is at position %ld\n",d,q1);

    d = 0.0;
    q1 = find_sorted<double>(&arr1,d);
    printf("%1.6g is at position %ld\n",d,q1);

    d = 0.123;
    q1 = find_sorted<double>(&arr1,d);
    printf("%1.6g is at position %ld\n",d,q1);

    d = -1.2;
    q1 = find_sorted<double>(&arr1,d);
    printf("%1.6g is at position %ld\n",d,q1);


    return;
  }

  void test_amsarray_sort_1()
  {
    amsarray<long> arr1;
    amsarray<long> perm1;
    amsarray<long> perm2;

    long I;
    long J;
    long N = 10;
    long t1,t2;

    arr1.resize(N);
    perm1.resize(N);
    perm2.resize(N);

    for(I=0;I<N;I++)
    {
      perm1[I] = I;
      arr1[I] = randi(0,N);
    }

    perm1[0] = 2;
    perm1[1] = 0;
    perm1[2] = 1;

    printf("Array:\n");
    printf_array(&arr1,1);
    printf("Permuation:\n");
    printf_array(&perm1,1);
    apply_permutation<long>(perm1,&arr1);
    printf("Array:\n");
    printf_array(&arr1,1);
    printf("Reverse Permuation:\n");
    invert_permutation(&perm1);
    printf_array(&perm1,1);
    apply_permutation<long>(perm1,&arr1);
    printf("Array:\n");
    printf_array(&arr1,1);
    printf("Sort Ascending Permuation:\n");
    sort_ascending_permutation<long>(&arr1,&perm2);
    printf_array(&perm2,1);
    apply_permutation(perm2,&arr1);
    printf("Array:\n");
    printf_array(&arr1,1);


    printf("Complexity Test:\n");
    printf("N\t\tTime\n");
    for(I=100;I<10000000;I=I*10)
    {
      arr1.resize(I);
      for(J=0;J<I;J++)
      {
        arr1[J] = randi(0,I);
      }
      t1 = (long)clock();
      sort_ascending<long>(&arr1);
      t2 = (long)clock();
      printf("%ld\t\t%ld\n",I,t2-t1);

    }


    return;
  }



}
